//==========================================================================
// DirectXライブラリ[dxlib.h]
// author: tatuya ogawa
//==========================================================================
#pragma once

//==========================================================================
// include
//==========================================================================
#include <Windows.h>
#include <direct.h>
#include <math.h>
#include <stdio.h>
#include <time.h>
#include <d3d9.h>
#include <d3dx9.h>
#include <XInput.h>
#include <XAudio2.h>
#include <codecvt> // c++ 文字コード変換
#include <cstdlib> // c++ 数値変換
#include <locale> // c++ 文字の判定
#include <system_error> // c++ OSエラー
#include <vector> // c++ 動的構造体
#include <list> // c++ 双方向list
#include <map> // c++ 平衡二分木 ソート機能付き
#include <unordered_map> // c++ 平衡二分木 ソート機能無し
#include <iomanip> // c++ 時間
#include <string> // c++ char
#include <random> // c++ rand
#include <fstream> // c++ file
#define DIRECTINPUT_VERSION (0x0800) // DirectInputのバージョン指定
#include <dinput.h>
#include <tchar.h>

//==========================================================================
// 独自lib include
//==========================================================================
#include "lib\mslib.hpp"
#include "lib\AspectRatio.h"
#include "lib\DX9_Object.h" // 継承用

/*

    // 初期化
    bool Init(void)override;

    // 解放
    void Uninit(void)override;

    // 更新
    void Update(void)override;

    // 描画
    void Draw(void)override;

    // デバッグ
    void Debug(void)override;


*/

#if 0

記述日 2018 / 07 / 10

● ver 2.1
・メルセンヌ・ツイスタの32ビット版、初期シード値生成関数の追加
・範囲の一様乱数 int バージョンを生成する関数の追加
・範囲の一様乱数 float バージョンを生成する関数の追加
・rand_int を定義しました。
・rand_float を定義しました。

● ver 2.0
・CObject 継承時のデバッグ機能の充実化(まだ足りない)
・タイマー機能の標準搭載。
・数字描画処理機能のバグ修正。
・CObject 継承時に名前を付ける機能。
・標準搭載された機能の中でインスタンス化された機能を自動的にデバッグに反映。
・デバッグ有効 / 無効化のチェックボックスの搭載
・各マネージャークラスの更新を停止させるチェックボックス

● ver 1.7 以前には存在し、ver 2.0 で廃止されたもの
・CObject 継承時に enum class で名前を付ける機能

#endif

#if 0

記述日 2018 / 07 / 10

●CObject
継承したクラスをマネージャークラスにする機能です。
CObject に標準機能として実装してある機能、
インスタンス化されるまで実体を持たない各機能が使えるようになります。

●このライブラリを使用した環境では以下の使用を推奨していません。
new / delete / malloc / free

● 継承時に必ず宣言しなければならない関数
bool Init(void)override;
void Uninit(void)override;
void Update(void)override;
void Draw(void)override;
void Debug(void)override;

● 継承時自動的に使用可能になる機能

==========================================================================
オブジェクトIDの設定
==========================================================================
CObject(ID ObjectID);

オブジェクトに対して、どういうオブジェクトを扱うのかを明確化することができます。
ここで設定したIDは、オブジェクトの探索時に使用します。

設定のしかた
コンストラクタ() : CObject(ID ObjectID) {}

オブジェクトIDの種類
[Default]デフォルトID設定です
[Camera]カメラIDです
[Grid]グリッドIDです
[Field]フィールドIDです
[Cube]キューブIDです
[Mesh]メッシュIDです
[Shadow]影IDです
[Sphere]球体IDです
[Xmodel]XモデルIDです
[Billboard]ビルボードIDです
[Polygon2D]2DポリゴンIDです
[Text]テキストIDです
[SpecialBlock]CObjectに認識されなくするIDです

==========================================================================
オブジェクト名のセット
==========================================================================
void SetObjectName(const std::string & ObjectName);

オブジェクトに名前を設定する関数です。
ここで設定した名前は、オブジェクトの探索時に使用します。

ObjectName オブジェクト名を入れてください

==========================================================================
オブジェクト名の取得
==========================================================================
const std::string * GetObjectName(void);

オブジェクトの名前を取得できます。

==========================================================================
オブジェクトの取得
==========================================================================
CObject * GetObjects(const ID ObjectID, const std::string & ObjectName);

CObject を継承した各インスタンスのオブジェクトを探索します。
探索成功時に、探索対象のオブジェクトの取得ができます。
失敗時には nullptr が返ります。

ObjectID には ID::でオブジェクトのIDを指定します。
ObjectName には 探索したいオブジェクトの名前を入力します。

==========================================================================
3Dオブジェクトインスタンス管理
==========================================================================
vector<C3DObject>*_3DObject(void);

3D描画に必要になる変数 C3DObject のインスタンスを好きなだけ生成 / 管理できる関数です。

==========================================================================
2Dオブジェクトインスタンス管理
==========================================================================
vector<C2DObject>*_2DObject(void);

2D描画に必要になる変数 C2DObject のインスタンスを好きなだけ生成 / 管理できる関数です。

==========================================================================
カメラインスタンス管理
==========================================================================
vector<CCamera> *Camera(void);

カメラのインスタンスを好きなだけ生成 / 管理が行える関数です。

==========================================================================
タイマーインスタンス管理
==========================================================================
vector<CTimer> *Timer(void);

タイマーのインスタンスを好きなだけ生成 / 管理が行える関数です。

==========================================================================
範囲の一様乱数(int)インスタンス管理
==========================================================================
vector<rand_int> * _rand_int(void);

範囲の一様乱数(int)のインスタンスを好きなだけ生成 / 管理が行える関数です。

==========================================================================
範囲の一様乱数(float)インスタンス管理
==========================================================================
vector<rand_float> * _rand_float(void);

範囲の一様乱数(float)のインスタンスを好きなだけ生成 / 管理が行える関数です。

==========================================================================
メルセンヌ・ツイスタの32ビット版、初期シード値の取得
==========================================================================
std::mt19937 & GetMt19937(void);

メルセンヌ・ツイスタの32ビット版、初期シード値の管理を行う関数です。
戻り値は初期シード値です。

==========================================================================
ライト
==========================================================================
CLight * Light(void);

ライトを設定する関数です。

==========================================================================
カメラの取得
==========================================================================
CCamera * GetCamera(int ID);

カメラの情報を取得できます。
GetObjects()でオブジェクトを取り出し、そこから呼び出さないと欲しい情報の取得ができません

ID には、カメラ番号を入れてください。
成功時にカメラのアドレスが取得できます。
失敗時に nullptr が返ります。

==========================================================================
カメラへ追従情報を渡す
==========================================================================
void SetCameraLockOn(int ID, const D3DXVECTOR3 & vpos);

カメラに対して、追従する対象の情報を渡せます。
GetObjects()でオブジェクトを取り出し、そこから呼び出さないとカメラに対して情報を渡せません。

ID には、カメラ番号を入れてください。
vpos には座標を入れてください。

ID 指定が間違って居る場合何も起きません

==========================================================================
特定オブジェクトの安全な破棄(C3DObject)
==========================================================================
void ObjectRelease(C3DObject * Input);

特定の C3DObject オブジェクトを安全な方法で破棄します。
違うオブジェクトから解放処理を行う場合安全に解放処理を行うための関数です。

Input には対象オブジェクトを入れてください

==========================================================================
特定オブジェクトの安全な破棄(C2DObject)
==========================================================================

特定の C2DObject オブジェクトを安全な方法で破棄します。
違うオブジェクトから解放処理を行う場合安全に解放処理を行うための関数です。

Input には対象オブジェクトを入れてください

==========================================================================
フィールド数
==========================================================================
int FieldSize(void);

_3DField()を使用し生成したフィールド数の取得ができます。
GetObjects()でオブジェクトを取り出し、そこから呼び出さないと欲しい情報の取得ができません

戻り値がフィールド数です。
_3DField()を使用し、フィールドを生成したのに0が返る場合は探索に失敗しています。

==========================================================================
指定フィールドとの当たり判定
==========================================================================
D3DXVECTOR3 FieldHeight(int FieldID, const D3DXVECTOR3 & vpos, int & HitID);

_3DField()を使用し生成したフィールドとの当たり判定を調べる関数です。
GetObjects()でオブジェクトを取り出し、そこから呼び出さないと欲しい情報の取得ができません

FieldID にはフィールドIDを入れてください
vpos には対象オブジェクトの座標を入れてください。
HitID 当たり判定高速化に必要な情報です。

戻り値は 当たり判定が検出された座標です。

==========================================================================
各描画機能を扱う関数
==========================================================================

2D系
[2Dポリゴン] C2DPolygon * _2DPolygon(void);
[数字] CNumber * _2DNumber(void);

3D系
[ビルボード] CBillboard *_3DBillboard(void);
[キューブ] CCube *_3DCube(void);
[メッシュ] CMesh *_3DMesh(void);
[フィールド] CMeshField *_3DField(void);
[丸影] CShadow *_3DA_CircleShadow(void);
[Xモデル] CXmodel *_3DXmodel(void);
[球体] CXmodel *_3DXmodel(void);

これらの描画機能には CObjectInput によって以下の共通の機能が提供されています。

void ObjectInput(C3DObject&Input);
void ObjectInput(C3DObject*Input);
void ObjectInput(C2DObject&Input);
void ObjectInput(C2DObject*Input);

描画機能に対して、描画対象のオブジェクトを渡します。
_3DObject(), _2DObject() で生成したオブジェクトを登録してください。
描画オブジェクトを登録しないと描画されない設計になっています。

void ObjectDelete(C3DObject&Input);
void ObjectDelete(C3DObject*Input);
void ObjectDelete(C2DObject&Input);
void ObjectDelete(C2DObject*Input);

描画機能から描画を止めたいオブジェクトを指定する関数です。
_3DObject(), _2DObject() で生成したオブジェクトを登録してください。

void ObjectRelease(void);

描画機能から、描画対象オブジェクトを解放します。
この時点で描画機能が停止します。

==========================================================================
便利関数
==========================================================================
[テキスト] CText *_2DText(void);
[ヘルパー] CTemplates * Helper(void);
[ImGui] CImGui_Dx9 * ImGui(void);
[グリッド] CGrid *_3DGrid(void);
[ウィンドウサイズ] * const vector2<int> GetWinSize(void);
[デバイス] LPDIRECT3DDEVICE9 GetDirectX9Device(void);

_2DText() テキスト描画を提供します。
Helper() 記述が面倒な関数を一行にした関数です。
ImGui() ImGuiの機能を最低限簡単に扱えるようにした関数です。
_3DGrid() ただのグリッドです。
GetWinSize() ウィンドウサイズの取得ができます。
GetDirectX9Device() デバイスの取得ができます。

==========================================================================
入力デバイス系
==========================================================================
[XInput] CXInput *XInput(void);
[XAudio] CXAudio2 *XAudio(void);
[DInputKeyboard] CKeyboard * Dinput_Keyboard(void);
[DInputMouse] CMouse * Dinput_Mouse(void);
[DInputController] CController * Dinput_Controller(void);

入力デバイスなどを提供する関数です。

==========================================================================
単純な衝突判定
==========================================================================
CHitDetermination * Collision(void);

単純なコリジョンを提供する関数です。

==========================================================================
デバッグ機能ON / OFF
==========================================================================
void DebugON(void);
void DebugOFF(void);

標準搭載されているデバッグ機能をON / OFFする関数です。

==========================================================================
デバッグオブジェクトの登録
==========================================================================
void Debug_3DObject(C3DObject* Input);

_3DObject()で生成していない C3DObject をデバッグ機能へ渡す機能です。
この処理は毎フレーム必要です。

==========================================================================
各クラスのインスタンス生成 / 管理 / 処理 / 解放を行う機能
これらの機能は呼び出す親クラスで使用してください
==========================================================================

CObject::NewObject();
CObjectを継承したクラスのインスタンスを生成できます。
引数には、各オブジェクトの空のポインタを入れてください。

以下の関数は Init() / Uninit() / Update() / Draw()に置いてください
CObject::InitAll();
CObject::ReleaseAll();
CObject::UpdateAll();
CObject::DrawAll();

#endif